
#-------------------------------------------------------------------------------
#                           IMAP-UTF7R[hϊCu
#                           Ver1.1
# 
# ϊe[u(uni2sjis.datAuni2sjis1.datAuni2euc.dat)Kvł
#
#-------------------------------------------------------------------------------

package imap_utf_conv;

$uni2sjis_dat  = './lib/dat/uni2sjis.dat' ;
$uni2sjis1_dat = './lib/dat/uni2sjis1.dat';
$uni2euc_dat   = './lib/dat/uni2euc.dat'  ;

%sjis2uni_hash = ();
%euc2uni_hash  = ();
$sjis2uni_flag = 0;
$euc2uni_flag  = 0;

%b64_encode = (
"000000", "A",  "000001", "B",  "000010", "C",  "000011", "D",
"000100", "E",  "000101", "F",  "000110", "G",  "000111", "H",
"001000", "I",  "001001", "J",  "001010", "K",  "001011", "L",
"001100", "M",  "001101", "N",  "001110", "O",  "001111", "P",
"010000", "Q",  "010001", "R",  "010010", "S",  "010011", "T",
"010100", "U",  "010101", "V",  "010110", "W",  "010111", "X",
"011000", "Y",  "011001", "Z",  "011010", "a",  "011011", "b",
"011100", "c",  "011101", "d",  "011110", "e",  "011111", "f",
"100000", "g",  "100001", "h",  "100010", "i",  "100011", "j",
"100100", "k",  "100101", "l",  "100110", "m",  "100111", "n",
"101000", "o",  "101001", "p",  "101010", "q",  "101011", "r",
"101100", "s",  "101101", "t",  "101110", "u",  "101111", "v",
"110000", "w",  "110001", "x",  "110010", "y",  "110011", "z",
"110100", "0",  "110101", "1",  "110110", "2",  "110111", "3",
"111000", "4",  "111001", "5",  "111010", "6",  "111011", "7",
"111100", "8",  "111101", "9",  "111110", "+",  "111111", ",",
);

# SJIS
$twoBytes_sjis = '(?:[\xA1-\xDF]|(?:[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]))'; # 1/2oCg SJIS

# EUC-JP
$twoBytes_euc = '(?:[\x8E\xA1-\xFE][\xA1-\xFE])'; # 2oCg EUC-JP


@zero = ( "", "00000", "0000", "000", "00", "0" );

return 1;

sub main::imap_utf_e{
	
	(*str,$mode) = @_;
	
	if ($mode eq "sjis"){
		$str =~ s/($twoBytes_sjis+)/'&'.&sjis2uni($1).'-'/geo;
	}else{
		$str =~ s/($twoBytes_euc+)/'&'.&euc2uni($1).'-'/geo;
	}
	
}

sub sjis2uni{
	
	($str2) = @_;
	
	if ($sjis2uni_flag == 0){
		open(IN,$uni2sjis_dat);
		$sjis2uni_size = -s $uni2sjis_dat;
		binmode IN;
		$size = 0;
		while($size <= $sjis2uni_size){
			read(IN,$uni ,2);
			read(IN,$sjis,2);
			$size += 4;
			$sjis2uni_hash{$sjis} = $uni;
		}
		close(IN);
		open(IN,$uni2sjis1_dat);
		$sjis2uni1_size = -s $uni2sjis1_dat;
		binmode IN;
		$size = 0;
		while($size <= $sjis2uni1_size){
			read(IN,$uni ,2);
			read(IN,$sjis,1);
			$size += 3;
			$sjis2uni_hash{$sjis} = $uni;
		}
		close(IN);
		$sjis2uni_flag = 1;
	}
	
	$size = 0;
	$max  = length($str2);
	$out = "";
	while($size <= $max){
		$t = $sjis2uni_hash{substr($str2,$size,2)};
		if ($t eq ""){ $t = $sjis2uni_hash{substr($str2,$size,1)}; $size += 1;}
		else         {                                             $size += 2;}
		$out .= $t;
	}
	
	$out  = unpack("B*", $out);
	$out .= $zero[(length($out))%6];
	$out  =~ s/.{6}/$b64_encode{$&}/go;
	
	return($out);
}

sub euc2uni{
	
	($str2) = @_;
	
	if ($euc2uni_flag == 0){
		$euc2uni_size = -s $uni2euc_dat;
		open(IN,$uni2euc_dat);
		binmode IN;
		$size = 0;
		while($size <= $euc2uni_size){
			read(IN,$uni ,2);
			read(IN,$euc ,2);
			$size += 4;
			$euc2uni_hash{$euc} = $uni;
		}
		close(IN);
		$euc2uni_flag = 1;
	}
	
	$max = length($str2);
	$out = "";
	foreach $a (0.. $max/2){
		$out .= $euc2uni_hash{substr($str2,$a*2,2)};
	}
	
	$out  = unpack("B*", $out);
	$out .= $zero[(length($out))%6];
	$out  =~ s/.{6}/$b64_encode{$&}/go;
	
	return($out);
}
