
#-------------------------------------------------------------------------------------------------------
# POP3OC
# &pop3login(<Pointer>,<ConfigPointer>);
# 
# Input : <Pointer>HashPointer   <ConfigPointer>HashPointer
#           None                   pop_server   --- POP Server
#                                  pop_port     --- POP Port
#                                  pop_account  --- POP Account
#                                  pop_password --- POP Password
#                                  pop_type     --- POP Type (apop|pop3)
#                                  pop_ssl      --- POP over SSL (ssl|"")
# Output: 1 | ErrNum
#
#-------------------------------------------------------------------------------------------------------

return 1;

sub pop3login{
	
	#---e擾
	my($lib_pf,$lib_cf) = @_;
	*lib_pp = $lib_pf;
	*lib_cp = $lib_cf;
	
	$mail_server   = $lib_cp{"pop_server"  };
	$mail_port     = $lib_cp{"pop_port"    };
	$mail_account  = $lib_cp{"pop_account" };
	$mail_password = $lib_cp{"pop_password"};
	$mail_type     = $lib_cp{"pop_type"    };
	$mail_ssl      = $lib_cp{"pop_ssl"     };
	
	#---POP3T[o[ڑ
	($rc,$type,$msg) = &connection_pop($mail_server,$mail_port,$mail_account,$mail_password,$mail_type,$mail_ssl);
	if ($rc ne "1"){ return('pop3login->'.$rc,$type,$msg);}

	$login_ctl{"pop"} = 1;
	return (1);
}

#------------------------------------------------------------------------------------------
# POP3T[o[ڑ/Login
# &connection_pop(<ServerDomain/IP>,<Port>,<Account>,<Password>,<Type[apop|smtp|"">,<SSL[1=use|]>;
#------------------------------------------------------------------------------------------
sub connection_pop{
	
	#---e^ݒ擾
	($mail_server,$mail_port,$mail_account,$mail_password,$mail_type,$mail_ssl) = @_;
	
	#---POP3͈ʓI110ԃ|[g
	if ($mail_port eq ""){ $mail_port = "110";}
	
	#----POP3 ւ TCP/IP ڑ
	if ($mail_ssl eq "1"){
		($rc,$type,$msg) = &execute('open_ssl_connection',$mail_server,$mail_port,'POP3');
		$pop_ssl_flag = 1;
	}else{
		($rc,$type,$msg) = &execute('open_tcp_connection',$mail_server,$mail_port,'POP3');
		$pop_ssl_flag = 0;
	}
	if ($rc ne "1"){ return('connection_pop->'.$rc,$type,$msg);}
	
	
	#-----Ready ?
	if ($timeout_time ne ""){ alarm($timeout_time);
	                          $timeout_msg = "TimeOutError (Server not ready)";}
	$rc = &pop3_rc();
	if( substr($rc,0,3) ne "+OK") { &execute("pop3logout","1");
			                            return('connection_pop','popready',$rc);}
	
	#---APOPF؁H
	($key) = $rc =~ /(<[^>]+>)/;
	
	$apop_f = 0;
	if   ($mail_type eq "apop"){ $apop_f = 1;}
	elsif($mail_type eq "pop3"){ $apop_f = 0;}
#	elsif($key       ne ""    ){ $apop_f = 1;}

	if ($apop_f == 1){
		
		$digest = &md5::convert($key.$mail_password);
		$digest = sprintf("%08x%08x%08x%08x", unpack('NNNN', $digest));
		
		#-----APOPF
		if ($timeout_time ne ""){ alarm($timeout_time);
		                          $timeout_msg = "TimeOutError (Account check)";}
		&pop3_tr("APOP $mail_account $digest\r\n");
		$rc = &pop3_rc();
		if(substr($rc,0,3) ne "+OK") { &execute("pop3logout");
			                             return('connection_pop','apop',$rc);}
		
	}else{
		
		#-----User (account)
		if ($timeout_time ne ""){ alarm($timeout_time);
		                          $timeout_msg = "TimeOutError (Account check)";}
		&pop3_tr("USER $mail_account\r\n");
		$rc = &pop3_rc();
		if(substr($rc,0,3) ne "+OK") { &execute("pop3logout");
			                             return('connection_pop','user',$rc);}
		
		#-----Password
		if ($timeout_time ne ""){ alarm($timeout_time);
		                          $timeout_msg = "TimeOutError (Password check)";}
		&pop3_tr("PASS $mail_password\r\n");
		$rc = &pop3_rc();
		if(substr($rc,0,3) ne "+OK") { &execute("pop3logout");
			                             return('connection_pop','pass',$rc);}
		
	}
	
	return(1);
	
}


