
#-------------------------------------------------------------------------------------------------------
# SieveXNvgo^
# &sieveset(<Pointer>,<ConfigPointer>);
# 
# Input : <Pointer>HashPointer   <ConfigPointer>HashPointer
#           data_pnt -- DataHashP  
#           mojicode -- JP Code    
#           scr_name -- ScriptName 
#                                  
# DataHash Format
#  max -- MAX_ID
#  <ID>-max  -- ID MaxItem
#  <ID>-name -- MailBox
#  <ID>-<ItemID>-type  -- in  || not
#  <ID>-<ItemID>-mode  -- and || or
#  <ID>-<ItemID>-match -- 1   || ""
#  <ID>-<ItemID>-head  -- <Header>
#  <ID>-<ItemID>-data  -- <Data>
#
# Output: 1 | ErrMsg
#
#-------------------------------------------------------------------------------------------------------
return 1;

sub sieveset{
	
	#---e擾
	(*lib_pointer,*lib_config) = @_;
	
	*data_p  = $lib_pointer{"data_pnt"};
	$default = $lib_pointer{"default" };
	$scr_name= $lib_pointer{"scr_name"};
	$mojicode= $lib_pointer{"mojicode"};
	if ($mojicode ne "euc"  &&
	    $mojicode ne "sjis" &&
	    $mojicode ne "jis"  ){ $mojicode = "euc";}
	
	#---G[`FbN
	if ($login_ctl{"sieve"} != 1 ){ return('sieveset','notlogin','SIEVE'); }
	if ($scr_name eq ""          ){ return('sieveset','noscrname');        }
	
	
	#---XNvgϊ---#
	$script   = "require \"fileinto\";\n\r";
	$scr_dat  = "# WebX Series Sieve Script Generator\r\n";
	$scr_dat .= "# START\r\n";
	$scr_dat .= "# $default\r\n";
	$scr_dat .= "# ---\n";
	
	$max_id = $data_p{"max"};
	foreach $a (0.. $max_id){
		$max_item = $data_p{$a."-max" };
		$name     = $data_p{$a."-name"};
		
		$scr_dat .= "# $name\r\n";
		
		foreach $b (0.. $max_item){
			$type  = $data_p{$a.'-'.$b.'-type' };
			$mode  = $data_p{$a.'-'.$b.'-mode' };
			$match = $data_p{$a.'-'.$b.'-match'};
			$head  = $data_p{$a.'-'.$b.'-head' };
			$data  = $data_p{$a.'-'.$b.'-data' };
			
			if ($mode  eq "or" ){ $t = "anyof"; }else{ $t = "allof";   }
			if ($match eq "1"  ){ $m = "match"; }else{ $m = "contains";}
			if ($type  eq "not"){ $e = "not ";  }else{ $e = "";        }
			
			if ($data eq ""){ next;}
			
			$scr_dat .= "# ".$type."\0".$mode."\0".$match."\0".$head."\0".$data."\0"."\r\n";
			$script  .= "if $e$t (\r\n";
			foreach $c (split(/\s/,$data)){
				$script .= "header :$m \"$head\" \"$c\",\r\n";
			}
			$script =~ s/,\r\n$/\r\n/;
			$script .= "){\n\r";
			if ($a == 0){ $script .= "  discard;\n\r";           }
			else        { $script .= "  fileinto \"$name\";\n\r";}
			$script .= "  stop;\r\n";
			$script .= "}\r\n";
			
		}
		$scr_dat .= "# ---\r\n";
	}
	$scr_dat .= "# END\r\n";
	$script  .= "fileinto \"$default\";\r\n" if $default ne "";
	$script  .= "\r\n";
	
	
	&mojicode'convert(*script,'utf-8');
	&jcode'convert(*scr_dat ,$mojicode);
	&jcode'convert(*scr_name,$mojicode);
#	&mojicode'convert(*scr_dat,'utf-8');
	
	$len = length($scr_dat)+length($script);
	
	&sieve_tr("putscript \"$scr_name\" {$len+}\r\n");
	&sieve_tr($scr_dat);
	&sieve_tr($script);
	&sieve_tr("\r\n");
	($rc,$out) = &sieve_rc();
	if ($rc ne "OK"){ return('sieveset','putscript',$rc."\n".$out);}
	
	return(1);
	
}
