#-------------------------------------------------------------------------------------------------------
# W[MW[ Ver2.0
# &mailsend(<Pointer>,<ConfigPointer>);
# 
# Output: ArrayPointer
# => <Status[OK or Error]>:<SendAddress>:<RcMessage>
#
#-------------------------------------------------------------------------------------------------------

return 1;
sub mailsend{
	
	my($lib_f,$conf_f) = @_;
	*lib_pointer = $lib_f;
	*lib_config  = $conf_f;
	
	#---eϐ擾
	my $mail_sender = $lib_pointer{"sender"   };
	my $mail_from   = $lib_pointer{"mail_from"};
	my $mail_self   = $lib_pointer{"selfaddr" };
	my $mail_rcpt   = $lib_pointer{"rcpt"     };
	my $mail_to     = $lib_pointer{"to"       };
	my $mail_cc     = $lib_pointer{"cc"       };
	my $mail_bcc    = $lib_pointer{"bcc"      };
	my $mail_into   = $lib_pointer{"into"     };
	my $sendmode    = $lib_pointer{"sendmode" };
	
	
	my $nslookup_path = $lib_config{"nslookup"    };
	my $dns_address   = $lib_config{"dns_address" };
	my $sendmail_path = $lib_config{"sendmail"    };
	my $use_sendmail  = $lib_config{"use_sendmail"};
	my $end_dot       = $lib_config{"end_dot"     };
	my $imap_usesend  = $lib_config{"use_send"    };
	my ($sbox,$sname) = split(/\0/,$lib_config{"sendbox"});
	
	#---M擾
	my($mail_addr) = $mail_from =~ /([0-9A-Za-z.\-_\?]+\@[0-9A-Za-z.\-_\?]+)/;
	if ($mail_addr eq ""  ){ $mail_addr = "localhost\@localdomain";}
	if ($mail_sender ne ""){ $mail_addr = $mail_sender;            }
	#---M惊XgAbv
	my %tmp = ();
	my $lib_a;
	my @sendtarget_list;
	foreach $lib_a (split(/,/,$mail_rcpt.",".$mail_to.",".$mail_cc.",".$mail_bcc)){
		my ($send) = $lib_a =~ /([0-9A-Za-z.\-_\?]+\@[0-9A-Za-z.\-_\?]+)/;
		if ($send       eq ""){ next;}
		if ($tmp{$send} ne ""){ next;}
		
		$tmp{$send} = "1";
		push(@sendtarget_list,$send);
	}
	push(@sendtarget_list,$mail_self) if $mail_self ne "";
	if ($sendmode ne "save"){
		return('mailsend','nosendto'  ) if $#sendtarget_list == -1;
		return('mailsend','nosendfrom') if $mail_addr eq "";
	}
	
	#---RFC822 Image
	my ($rc,$rfcmsg,$errmsg) = &execute('make_rfc822',$mail_addr,$lib_f,$conf_f);
	if ($rc ne "1"){ return('mailsend->'.$rc,$rfcmsg,$errmsg);}
	
	#---MJn
	my($rc,$msg,$errmsg);
	if   ($sendmode eq "mta"     ){ ($rc,$msg,$errmsg) = &execute('send_mta'     ,$mail_addr,\@sendtarget_list,$nslookup_path,$dns_address,$rfcmsg);}
	elsif($sendmode eq "sendmail"){ ($rc,$msg,$errmsg) = &execute('send_sendmail',$mail_addr,\@sendtarget_list,$sendmail_path,$rfcmsg,$end_dot);    }
	elsif($sendmode eq "save"    ){ ($rc,$msg,$errmsg) = &execute('send_save'    ,$mail_into,$rfcmsg,$conf_f,'');                                   }
	else                          { ($rc,$msg,$errmsg) = &execute('send_smtp'    ,$mail_addr,\@sendtarget_list,$rfcmsg,$conf_f);                    }
	if ($rc ne "1"){ return('mailsend->'.$rc,$msg,$errmsg);}
	
	if ($imap_usesend eq "1" && $sendmode ne "save"){
		my($rc,$msg,$errmsg) = &execute('send_save',$sbox,$rfcmsg,$conf_f,'/');
		if ($rc ne "1"){ return('mailsend->'.$rc,$msg,$errmsg);}
	}
	&execute('imap4logout',"",$conf_f);
	
	return($rc,$msg,$errmsg);
}
