#-------------------------------------------------------------------------------------------------------
# W[MW[ W[ - RFC822 ImageGenerator
# &make_rfc822(<Pointer>,<ConfigPointer>);
# 
# Output: ArrayPointer
# => <Status[OK or Error]>:<RFC822 StringPointer>)
#
#-------------------------------------------------------------------------------------------------------

return 1;

sub make_rfc822{
	
	my($mail_addr,$lib_f,$lib_cf) = @_;
	*lib_p = $lib_f;
	
	#---eϐ擾
	my $mail_from   = $lib_p{"from"       };
	my $mail_to     = $lib_p{"to"         };
	my $mail_cc     = $lib_p{"cc"         };
	my $mail_bcc    = $lib_p{"bcc"        };
	my $mail_subj   = $lib_p{"subject"    };
	my $mail_reply  = $lib_p{"reply-to"   };
	my $mail_date   = $lib_p{"date"       };
	my $mail_repl   = $lib_p{"in-reply-to"};
	my $mail_ref    = $lib_p{"references" };
	my $mail_head   = $lib_p{"other_head" };
	my $mail_body   = $lib_p{"message"    };
	my $mail_id     = $lib_p{"message-id" };
	my $mail_file_f = $lib_p{"sendfile"   };
	my $mail_fow    = $lib_p{"foward"     };
	my $mail_box    = $lib_p{"mailbox"    };
	my $mailsign_str= $lib_p{"mailsign"   };
	my $con_type    = $lib_p{"mode"       };
	

	#---ϐ
	*mail_file = $mail_file_f;
	my @file_list     = keys(%mail_file);
	my $boundary_data = "";
	my $content_type  = "";
	#---Content-TypeF
	if ($mail_fow ne "" || $#file_list != -1 ){ #-----boundary̍쐬
		$boundary_data = localtime;
		$boundary_data =~ tr/ :/__/d;
		$boundary_data = "--NEXT_PART_$boundary_data==";
		$content_type = "Multipart/Mixed\; boundary=\"$boundary_data\"";
	}else{
		$content_type = "text/plain\; charset=iso-2022-jp";
	}
	
	#---Mt@CL^Jn
	$rfc822_img = "";
	
	#---To/Cc/Bcc`
	$mail_cc    =~ s/,+$//;
	$mail_cc    =~ s/,/,\n    /g;
	$mail_bcc   =~ s/,+$//;
	$mail_bcc   =~ s/,/,\n    /g;
	$mail_to    =~ s/,+$//;
	$mail_to    =~ s/,/,\n    /g;
	$mail_reply =~ s/,+$//;
	$mail_reply =~ s/,/,\n    /g;
	
	#-----------------------------{M-------------------------------#
	
	#---wb_[쐬
	my $header  = "From: $mail_from\n";
	$header .= "To: $mail_to\n";
	$header .= "Subject: $mail_subj\n";
	$header .= "Mime-Version: 1.0\n";
	$header .= "Content-type: $content_type\n";
	$header .= "Content-Transfer-Encoding: 7bit\n";
	
	#---ǉwb_[
	if ($mail_date  eq ""){ my $send_date = &mailcontrol_getdate();
	                        $header .= "Date: $send_date\n";
	                                                               }
	else                  { $header .= "Date: $mail_date\n";       }
	if ($mail_cc    ne ""){ $header .= "Cc: $mail_cc\n";           }
	if ($mail_reply ne ""){ $header .= "Reply-To: $mail_reply\n";  }
	if ($mail_repl  ne ""){ $header .= "In-Reply-To: $mail_repl\n";}
	if ($mail_ref   ne ""){ $header .= "References: $mail_ref\n";  }
	if ($mail_id    eq ""){ $header .= "Message-Id: <".&mailcontrol_getmsgid($mail_addr).">\n";}
	else                  { $header .= "Message-Id: <".$mail_id.">\n";                         }
	
	&main::jcode'convert(\$header,"jis");
	$header = &main::mimeencode($header);
	$rfc822_img .=$header."\n";
	
	#---}`p[g
	if ($boundary_data ne ""){
		my $header2  = "--$boundary_data\n";
		$header2 .= "Content-Type: text/plain; ";
		$header2 .= "charset=\"iso-2022-jp\"\n";
		$header2 .= "Content-Transfer-Encoding: 7bit\n\n";
		$rfc822_img .=$header2;
	}
	
	#---Body
	my $lib_c;
	$mail_body    =~ tr/\r//d;
	$mailsign_str =~ tr/\r//d;
	&main::jcode'convert(\$mail_body,"jis");
	&main::jcode'convert(\$mailsign_str,"jis");
	$rfc822_img .= $mail_body."\n";
	$rfc822_img .= $mailsign_str."\n";
	$rfc822_img .= "\n";
	
	#-------------------------tH[hM----------------------------#
	
	if ($mail_fow ne ""){
		
		my $header2  = "--$boundary_data\n";
		$header2 .= "Content-Type: message/rfc822\n";
		$header2 .= "Content-Description: FwMail\n\n";
		$rfc822_img .=$header2;
		
		if ($con_type eq "imap" && $mail_box ne ""){
			
			#---IMAP4T[o[ڑ
			my($rc,$type,$msg) = &execute("imap4login","",$lib_cf);
			if ($rc ne "1"){ &execute("imap4logout");
			                 return('mxsendmail->'.$rc,$type,$msg);}
			
			#---[{bNXI
			if ($timeout_time ne ""){ alarm($timeout_time);
			                          $timeout_msg = "TimeOutError: SELECT Command";}
			my ($rc,$com) = &imap4_com("SELECT \"$mail_box\"");
			if (substr($rc,0,2) ne "OK"){ &execute("imap4logout");
			                              return('make_rfc822','select',$rc."\n".$com);}
			
			&imap4_tr("0000 FETCH ".$mail_fow." RFC822\r\n");
			my $msg = &imap4_rc();
			if (substr($msg,0,4) eq "0000"){ &execute("imap4logout");
			                                 return('make_rfc822','fetch',$msg);}
			my($total_size) = $msg =~ /\{(\d+)\}/;
			my $nowsize=0;
			
			while(1){
				if ($nowsize >= $total_size){ last;}
				my $buf = &imap4_rc();
				$nowsize += length($buf);
				
				$buf  =~ tr/\r//d;
				$rfc822_img .= $buf;
			}
			$msg = &imap4_rc();
			if (substr($msg,0,1) eq ")"){
				$msg = &imap4_rc();
			}
			while(substr($msg,0,1) eq "*"){
				$msg = &imap4_rc();
			}
			if (substr($msg,0,4) ne "0000" || substr($msg,5,2) ne "OK"){
				&execute('imap4logout');
				return('make_rfc822','fetch',$msg);
			}
			
			&execute("imap4logout");
			
		}elsif($con_type ne "imap"){

			#---POP3T[o[ڑ
			my ($rc,$type,$msg) = &execute("pop3login","",$lib_cf);
			if ($rc ne "1"){ &execute("pop3logout");
			                 return('mxsendmail->'.$rc,$type,$msg);}
			
			#---[M
			if ($timeout_time ne ""){ alarm($timeout_time);
			                          $timeout_msg = "TimeOutError: RETR Command";}
			&pop3_tr("RETR $mail_fow\r\n");
			my $rc = &pop3_rc();
			if( $rc !~ /\+OK/ ) { &execute("pop3logout");
			                      return('make_rfc822','retr',$rc);                }
			
			if ($timeout_time ne ""){ alarm(0);}
			
			while(1){
				my $buf = &pop3_rc();
				$buf =~ tr/\r//d;
				if ($buf eq ".\n"){ last;}
				if ($buf =~ /^\.+\n/){ $rfc822_img .= substr($buf,1);}
				else                 { $rfc822_img .=$buf;           }
			}
			
			&execute("pop3logout");
		}
	}
	
	#-------------------------t@CM----------------------------#
	if ($#file_list != -1){
		my $lib_a;
		foreach $lib_a (keys(%mail_file)){
			
			my ($name,$type) = split(/:/,$lib_a);
			
			#---Content-TypeF
			if ($type eq ""){ my($type_data) = $name =~ /\.(\w+)$/;
			                  $type_data =~ tr/A-Z/a-z/;
			                  $type = $kakutyousi{$type_data};
			                                                     }
			if ($type eq ""){ $type = "application/octet-stream";}

			&main::jcode'convert(\$name,"jis");
			$name = &main::mimeencode($name);
			
			#---wb_[M
			my $header2  = "--$boundary_data\n";
			$header2 .= "Content-Type: $type\; name=\"$name\"\n";
			$header2 .= "Content-Disposition: attachment\; filename=\"$name\"\n";
			$header2 .= "Content-Transfer-Encoding: base64\n\n";
			
			&main::jcode'convert(\$header2,"jis");
			$rfc822_img .=$header2;
			
			#---{fBM
			$rfc822_img .=&main::bodyencode($mail_file{$lib_a});
			$rfc822_img .=&main::benflush();
			
			$rfc822_img .="\n";
			
		}
		
	}
	
	#---I
	if ($boundary_data ne ""){ $rfc822_img .="--$boundary_data--\n\n";}
	
	return('1',\$rfc822_img);
}

