
$minidb_fname   = "";
$minidb_recsize = "";

return 1;

sub sys_minidb{
	my($mode,@opt) = @_;
	
	if   ($mode eq "newrec"){ return(&sys_minidb_newrec(@opt));}
	elsif($mode eq "update"){ return(&sys_minidb_update(@opt));}
	elsif($mode eq "get"   ){ return(&sys_minidb_get   (@opt));}
	elsif($mode eq "list"  ){ return(&sys_minidb_list  (@opt));}
	elsif($mode eq "delete"){ return(&sys_minidb_delete(@opt));}
	elsif($mode eq "open"  ){ return(&sys_minidb_open  (@opt));}
	elsif($mode eq "close" ){ return(&sys_minidb_close (@opt));}
	
}

sub sys_minidb_open{
	my($recsize,$db_name) = @_;
	$minidb_fname  = $conf_dir.$db_name;
	$minidb_recsize= $recsize;
	
	if (! open(DB,"+<".$minidb_fname)){ &error('MiniDB','OpenError:'.$db_name);}
	flock(DB,2);
	binmode DB;
	
	return(1);
}

sub sys_minidb_close{
	
	flock(DB,8);
	close(DB);
	
	return(1);
}

sub sys_minidb_get{
	my($sid) = @_;
	my $buf;
	
	seek(DB,$minidb_recsize*$sid,0);
	read(DB,$buf,1);
	if ($buf eq "0"){ return('');}
	read(DB,$buf,3);
	read(DB,$buf,$buf);
	
	return($buf);
}

sub sys_minidb_update{
	my($sid,$dat) = @_;
	my $len = sprintf('%03d',length($dat));
	
	seek(DB,$minidb_recsize*$sid,0);
	print DB "1".$len.$dat;
	
	return(1);
}

sub sys_minidb_delete{
	my($sid) = @_;
	
	seek(DB,$minidb_recsize*$sid,0);
	print DB "0";
	
	return(1);
}

sub sys_minidb_newrec{
	my($recsize,$db_name) = @_;
	
	my $use_fname = $conf_dir.$db_name;
	if (!-e $use_fname){ 
		open(DB,">".$use_fname);
		close(DB);
	}
	my $size = -s $use_fname;
	if ($size != 0){
		if (!open(DB,$use_fname)){ &error('MiniDB','ReadError:'.$db_name);}
		flock(DB,2);
		binmode DB;
		my $pos = int($size / $recsize);
		   $pos-- if $size % $recsize == 0;
		my $buf;
		foreach (0.. $pos){
			seek(DB,$_*$recsize,0);
			read(DB,$buf,1);
			if ($buf eq "0"){ close(DB); return($_);}
		}
		return($pos+1);
		flock(DB,8);
		close(DB);
	}else{
		return("0");
	}
}

sub sys_minidb_list{
	my($recsize,$db_name) = @_;
	
	my $use_fname = $conf_dir.$db_name;
	my $size = -s $use_fname;
	@minidb_list = ();
	if ($size != 0){
		if (!open(DB,$use_fname)){ &error('MiniDB','ReadError:'.$db_name);}
		flock(DB,2);
		binmode DB;
		my $pos = int($size / $recsize);
		   $pos-- if $size % $recsize == 0;
		my $buf;
		foreach (0.. $pos){
			seek(DB,$_*$recsize,0);
			read(DB,$buf,1);
			if ($buf eq "0"){ next;}
			read(DB,$buf,3);
			read(DB,$buf,$buf);
			push(@minidb_list,$_."\0".$buf);
		}
		flock(DB,8);
		close(DB);
	}
	return(\@minidb_list);
}
